加载中...
1237-找出给定方程的正整数解(Find Positive Integer Solution for a Given Equation)
发表于:2021-12-03 | 分类: 中等
字数统计: 857 | 阅读时长: 4分钟 | 阅读量:

原文链接: https://leetcode-cn.com/problems/find-positive-integer-solution-for-a-given-equation

英文原文

Given a callable function f(x, y) with a hidden formula and a value z, reverse engineer the formula and return all positive integer pairs x and y where f(x,y) == z. You may return the pairs in any order.

While the exact formula is hidden, the function is monotonically increasing, i.e.:

  • f(x, y) < f(x + 1, y)
  • f(x, y) < f(x, y + 1)

The function interface is defined like this:

interface CustomFunction {
public:
  // Returns some positive integer f(x, y) for two positive integers x and y based on a formula.
  int f(int x, int y);
};

We will judge your solution as follows:

  • The judge has a list of 9 hidden implementations of CustomFunction, along with a way to generate an answer key of all valid pairs for a specific z.
  • The judge will receive two inputs: a function_id (to determine which implementation to test your code with), and the target z.
  • The judge will call your findSolution and compare your results with the answer key.
  • If your results match the answer key, your solution will be Accepted.

 

Example 1:

Input: function_id = 1, z = 5
Output: [[1,4],[2,3],[3,2],[4,1]]
Explanation: The hidden formula for function_id = 1 is f(x, y) = x + y.
The following positive integer values of x and y make f(x, y) equal to 5:
x=1, y=4 -> f(1, 4) = 1 + 4 = 5.
x=2, y=3 -> f(2, 3) = 2 + 3 = 5.
x=3, y=2 -> f(3, 2) = 3 + 2 = 5.
x=4, y=1 -> f(4, 1) = 4 + 1 = 5.

Example 2:

Input: function_id = 2, z = 5
Output: [[1,5],[5,1]]
Explanation: The hidden formula for function_id = 2 is f(x, y) = x * y.
The following positive integer values of x and y make f(x, y) equal to 5:
x=1, y=5 -> f(1, 5) = 1 * 5 = 5.
x=5, y=1 -> f(5, 1) = 5 * 1 = 5.

 

Constraints:

  • 1 <= function_id <= 9
  • 1 <= z <= 100
  • It is guaranteed that the solutions of f(x, y) == z will be in the range 1 <= x, y <= 1000.
  • It is also guaranteed that f(x, y) will fit in 32 bit signed integer if 1 <= x, y <= 1000.

中文题目

给你一个函数  f(x, y) 和一个目标结果 z,函数公式未知,请你计算方程 f(x,y) == z 所有可能的正整数 数对 xy。满足条件的结果数对可以按任意顺序返回。

尽管函数的具体式子未知,但它是单调递增函数,也就是说:

  • f(x, y) < f(x + 1, y)
  • f(x, y) < f(x, y + 1)

函数接口定义如下:

interface CustomFunction {
public:
  // Returns some positive integer f(x, y) for two positive integers x and y based on a formula.
  int f(int x, int y);
};

你的解决方案将按如下规则进行评判:

  • 判题程序有一个由 CustomFunction9 种实现组成的列表,以及一种为特定的 z 生成所有有效数对的答案的方法。
  • 判题程序接受两个输入:function_id(决定使用哪种实现测试你的代码)以及目标结果 z
  • 判题程序将会调用你实现的 findSolution 并将你的结果与答案进行比较。
  • 如果你的结果与答案相符,那么解决方案将被视作正确答案,即 Accepted

 

示例 1:

输入:function_id = 1, z = 5
输出:[[1,4],[2,3],[3,2],[4,1]]
解释:function_id = 1 暗含的函数式子为 f(x, y) = x + y
以下 x 和 y 满足 f(x, y) 等于 5:
x=1, y=4 -> f(1, 4) = 1 + 4 = 5
x=2, y=3 -> f(2, 3) = 2 + 3 = 5
x=3, y=2 -> f(3, 2) = 3 + 2 = 5
x=4, y=1 -> f(4, 1) = 4 + 1 = 5

示例 2:

输入:function_id = 2, z = 5
输出:[[1,5],[5,1]]
解释:function_id = 2 暗含的函数式子为 f(x, y) = x * y
以下 x 和 y 满足 f(x, y) 等于 5:
x=1, y=5 -> f(1, 5) = 1 * 5 = 5
x=5, y=1 -> f(5, 1) = 5 * 1 = 5

 

提示:

  • 1 <= function_id <= 9
  • 1 <= z <= 100
  • 题目保证 f(x, y) == z 的解处于 1 <= x, y <= 1000 的范围内。
  • 1 <= x, y <= 1000 的前提下,题目保证 f(x, y) 是一个 32 位有符号整数。

通过代码

高赞题解

暴力法

思路

  • 遍历 x 从 1 到 z 的所有组合
    • 遍历 y 从 1 到 z 的所有组合
    • 如果两者作为变量使函数值等于目标值
    • 添加到答案中
  • 输出
  • 不推荐这个做法,完全没有利用到「递增」这个条件

    代码

  • 一行搞定
    class Solution:
        def findSolution(self, customfunction: 'CustomFunction', z: int) -> List[List[int]]:
            return [[x,y]for x in range(1,z+1) for y in range(1,z+1) if customfunction.f(x,y) == z]

    复杂度分析

  • 时间复杂度 $O(Z^2)$
  • 空间复杂度,不算记录答案的空间是 $O(1)$

二分查找法

思路

  • 先遍历 x
    • 对于每个 x ,可能存在一个对应的 y
    • 而 y 以及 f(x,y) 的值随着 y 的增加是增加的
    • 因此可以使用二分查找
  • 不推荐使用这个做法,因为只利用到了函数 f 对 y 变量是递增的,没有利用到对 x 也是这样。

    代码

    class Solution:
        def findSolution(self, customfunction: 'CustomFunction', z: int) -> List[List[int]]:
            ans = []
            for x in range(1,z+1):
                left, right = 1, z
                while left < right:
                    mid = (left + right) // 2
                    res = customfunction.f(x,mid)
                    if res < z:
                        left = mid + 1
                    else:
                        right = mid
                if customfunction.f(x,left) == z:
                    ans.append([x,left])
            return ans
    

    复杂度

  • 时间复杂度 $O(ZlogZ)$
  • 空间复杂度,不算记录答案的空间是 $O(1)$

双指针法

思路

  • 由于函数 f 对于两个变量的偏导都是正的,那么可以使用双指针法。
  • 我们思考,先固定 x ,从1 开始,那么可以让 y 从后往前找到匹配值
  • 如果匹配到了以后,那么对应于这个 x 已经没用了,x 可以增加
  • 同时增加后的 x 要匹配的 y 就一定比上一个 y 少。
  • 这就是双指针法的思路。
  • 具体来讲就是
  • 一个 x 指向头(1),一个 y 指向尾(1000)
  • 判断 x 和 y 能否使得函数值等于 z
    • 当这个函数值小了,就增加 x
    • 当这个函数值大了,就减少 y
    • 相等的时候添加到答案,同时 x 和 y 一起更新。
  • 推荐使用这个方法,利用了函数 f 对两个变量的偏导都是正的这个条件。

    代码

    class Solution:
        def findSolution(self, customfunction: 'CustomFunction', z: int) -> List[List[int]]:
            ans,x,y = [],1,1000
            while x <= 1000 and y >= 1:
                res = customfunction.f(x,y)
                if res < z:
                    x += 1
                elif res > z: 
                    y -= 1
                if res == z:
                    ans.append([x,y])
                    x += 1
                    y -= 1
            return ans

    复杂度分析

  • 时间复杂度 $O(Z)$
  • 空间复杂度,不算记录答案的空间是 $O(1)$

统计信息

通过次数 提交次数 AC比率
10317 14514 71.1%

提交历史

提交时间 提交结果 执行时间 内存消耗 语言
上一篇:
1235-规划兼职工作(Maximum Profit in Job Scheduling)
下一篇:
1238-循环码排列(Circular Permutation in Binary Representation)
本文目录
本文目录